MAXScript Extensions > MAXScript Extensions for Particle Flow > Particle Flow Classes > Meta-Operators >

# Cache : Helper

    Cache - superclass: helper; super-superclass:node - classID: #(1962490661, 515064320)

Value > MAXWrapper > Node > Helper > Cache

| Particle Flow - Quick Navigation

Description:

The Cache operator records and stores particle states to memory.

Constructor:

    Cache...

Properties:

    <Cache>.Use_At Integer default: 0 -- integer

Controls the state of Use At drop-down list.

Possible values are:

0: Viewport

1: Render

2: Viewport/Render

    <Cache>.Update_Type Integer default: 0 -- integer

Controls the state of the Update drop-down list. Determines whether Particle Flow should update the cache automatically, or let you do it manually.

0: Always - Changing any parameter under the Cache operator's purview causes it automatically to update stored data from the start of the current range (see next parameter) to the current frame.

1: Manually - updating occurs only when you click the Update button, or clear the cache and then move to a different frame.

    <Cache>.Range_Type Integer default: 1 -- integer

Controls the index of the Range drop-down list. Sets the frame range within which the Cache operator operates:

0: Complete - The software caches the entire animation.

1: Active Segment - The software caches only frames in the active segment, as defined by the Start Time and End Time settings on the Time Configuration dialog.

2: Custom - The software caches only frames in the custom range, as defined by the Cache operator's Start Time and End Time settings (see following).

    <Cache>.Start_Time Time default: 0f -- time

The first frame of the range considered for caching when .Range_Type is set to 2 : Custom

    <Cache>.End_Time Time default: 30f -- time

The last frame of the range considered for caching when .Range_Type is set to 2 : Custom

    <Cache>.Sampling_Type Integer default: 0 -- integer

Controls the state of the Sampling drop-down list.

    <Cache>.Every_Nth_Frame Integer default: 5 -- integer

Specifies the Nth frame to sample.

    <Cache>.Cache_Test_Results BooleanClass default: true -- boolean

When caching particle data, setting this to true caches the results of test actions as well.

This is important if Cache is used as a local operator, and the next event doesn’t have a Cache operator. For the next event to work properly, it should receive particles from the current event. Those particles result from the activity of a test action. The Cache operator can record the test activity to play it back later.

If the Cache operator is used as a global operator, there is no need to cache the test results. This is because the system has cache data for every event, and is able to jump to an arbitrary frame without the need for test results.

    <Cache>.Cache_With_Hold BooleanClass default: false -- boolean

When set to true, cached data will be saved with backup files.

    <Cache>.Cache_With_File BooleanClass default: false -- boolean; alias:Record_Hold

When set to true, cached data will be saved in the Hold file.

    <Cache>.Clear_Range_Type Integer default: 1 -- integer; alias: Range_Type

Controls the state of the Manual Update Range drop-down list in the UI. Specifies the frame range within which the Cache operator recalculates data when using Manual Update.

Possible values are:

0: Complete - The software clears the cache for entire animation. Choosing Complete makes the Update button unavailable; this option is for clearing the cache only.

1: Active Segment - The software updates the cache only for frames in the active segment, as defined by the Start Time and End Time settings on the Time Configuration dialog.

2: Custom - The software updates the cache only for only frames in the custom range, as defined by the Clear_ Start_Time and Clear_End_Time properties (see below).

    <Cache>.Clear_Start_Time Time default: 0f -- time

The first frame of the range considered for caching when .Clear_Range_Type is set to 1 : Custom (see above).

    <Cache>.Clear_End_Time Time default: 30f -- time

The last frame of the range considered for caching when .Clear_Range_Type is set to 1 : Custom (see above).

    <Cache>.Memory_Limit Integer default: 100000 -- integer; alias: Memory_Limit__K

Get/Set the maximum amount of system memory used to cache particle data, in kilobytes.

    <Cache>.Memory_Total Integer default: 0 -- integer; alias: Memory_Total__K

Returns the amount of memory currently used by the cached data, in kilobytes. Read-only.

    <Cache>.Memory_for_Current_Frame Integer default: 0 -- animatable; integer alias: Memory_for_Current_Frame__K

Returns the amount of memory used by the data cached for the current frame, in kilobytes. Read-only.

## Cache Interfaces:

The following Interfaces are exposed by the Cache Class:

Interface: action

Interface: operator

#### See Also

- Particle Flow Classes